//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  Delphi  IDE ̍\yCƓ擾Tv
//  ToolaAPI gp
//
//-----------------------------------------------------------------------------
//
//  2020N1107 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit plDialogStructForm;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, 
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

  procedure StructureViewToSL(ASL: TStringList);

var
  Form1: TForm1;

implementation

uses
  ToolsAPI,
  StructureViewAPI;

{$R *.dfm}

{ TTForm1 }

//=============================================================================
//  tH[\鎞̃Cxg
//=============================================================================
procedure TForm1.FormShow(Sender: TObject);
var
  LStrList : TStringList;
begin
  Self.Caption := '\';

  Memo1.Lines.Clear;
  Memo1.ScrollBars := ssBoth;
  Memo1.Font.Size  := 11;
  Memo1.Font.Name  := 'Courier New';

  LStrList := TStringList.Create;
  try
    StructureViewToSL(LStrList);
    Memo1.Lines.Text := LStrList.Text;
  finally
  end;
end;

//-----------------------------------------------------------------------------
//  Delphi  IDE ̍\yCƓ擾ĕ\
//  ݃ANeBuȃW[̏
//  ʂ [c[| [IvV] [IvV] [GNXv[] ̐ݒɈˑ
//
//  uses  ToolsAPI, StructureViewAPI Kv
//-----------------------------------------------------------------------------
procedure StructureViewToSL(ASL: TStringList);

  procedure TreeToSL(ANode: IOTAStructureNode; ASL: TStringList; const APrefix: string);
  var
    I: Integer;
  begin
    ASL.Add(APrefix + ANode.Caption);
    for I := 0 to ANode.ChildCount - 1 do begin
      TreeToSL(ANode.Child[I], ASL, APrefix + '  ');
    end;
  end;

var
  StructureView: IOTAStructureView;
  StructureContext: IOTAStructureContext;
  Node: IOTAStructureNode;
  I: Integer;
begin
  StructureView := BorlandIDEServices as IOTAStructureView;
  StructureContext := StructureView.GetStructureContext;
  for I := 0 to StructureContext.RootNodeCount - 1 do
  begin
    Node := StructureContext.GetRootStructureNode(I);
    TreeToSL(Node, ASL, '');
  end;
end;

end.
